"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var fs = require('fs-extra');
var path = require('path');
var ora = require('ora');
var kebabCase = require('lodash.kebabcase');
var _a = require('@toptal/davinci-cli-shared'), print = _a.print, run = _a.run;
var skeleton = require('../utils/skeleton');
var checkPrerequisites = function (destDir, appName) { return __awaiter(void 0, void 0, void 0, function () {
    var spinner, err_1, doesAppExist;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                spinner = ora('Checking prerequisites...').start();
                _a.label = 1;
            case 1:
                _a.trys.push([1, 3, , 4]);
                return [4 /*yield*/, run('direnv', ['version'])];
            case 2:
                _a.sent();
                return [3 /*break*/, 4];
            case 3:
                err_1 = _a.sent();
                spinner.warn();
                print.yellow("warning: You don't have `direnv` for resolving env variables! Expect other approach is used.");
                return [3 /*break*/, 4];
            case 4: return [4 /*yield*/, fs.exists(destDir)];
            case 5:
                doesAppExist = _a.sent();
                if (doesAppExist) {
                    spinner.fail();
                    throw new Error("Application with name ".concat(appName, " already exists!"));
                }
                spinner.succeed('Prerequisites checked!');
                return [2 /*return*/];
        }
    });
}); };
var copyApplicationSkeleton = function (destDir, currentDavinciRunningDir) { return __awaiter(void 0, void 0, void 0, function () {
    var skeletonPath, appDir, spinner, err_2;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                skeletonPath = require.resolve('@toptal/davinci-skeleton', {
                    paths: [currentDavinciRunningDir],
                });
                appDir = path.join(skeletonPath, '../..');
                spinner = ora('Copying skeleton...').start();
                _a.label = 1;
            case 1:
                _a.trys.push([1, 9, , 10]);
                return [4 /*yield*/, skeleton.copyAllFiles(appDir, destDir)];
            case 2:
                _a.sent();
                return [4 /*yield*/, skeleton.copySPAWorkflows(appDir, destDir)];
            case 3:
                _a.sent();
                return [4 /*yield*/, skeleton.copyNpmrc(destDir)];
            case 4:
                _a.sent();
                return [4 /*yield*/, skeleton.copyTemplatePackageJsonFile(destDir)];
            case 5:
                _a.sent();
                return [4 /*yield*/, skeleton.copyTemplateGitIgnoreFile(destDir)];
            case 6:
                _a.sent();
                return [4 /*yield*/, skeleton.copyTemplateEslintrc(destDir)
                    // remove bin directory
                ];
            case 7:
                _a.sent();
                // remove bin directory
                return [4 /*yield*/, fs.remove(path.join(destDir, 'bin'))];
            case 8:
                // remove bin directory
                _a.sent();
                spinner.succeed('Skeleton copied!');
                return [3 /*break*/, 10];
            case 9:
                err_2 = _a.sent();
                spinner.fail();
                throw err_2;
            case 10: return [2 /*return*/];
        }
    });
}); };
var modifyPackageJson = function (destDir, appName) { return __awaiter(void 0, void 0, void 0, function () {
    var spinner, config;
    return __generator(this, function (_a) {
        spinner = ora('Modifiying package.json...').start();
        try {
            config = skeleton.readPackageJson(destDir);
            config.name = "@toptal/".concat(appName);
            config.homepage = "https://github.com/toptal/".concat(appName, "/tree/master#readme");
            delete config.gitHead;
            delete config.scripts['prepack'];
            delete config.scripts['postpack'];
            delete config.scripts['build:package'];
            delete config.scripts['prepublishOnly'];
            // add husky scripts
            config.scripts.prepare = "if [ -d '.git' ]; then husky install; fi";
            delete config.publishConfig;
            config.license = 'SEE LICENSE IN LICENSE.MD';
            config.version = '0.0.1';
            skeleton.writePackageJson(destDir, config);
            spinner.succeed('package.json modified!');
        }
        catch (err) {
            spinner.fail();
            throw err;
        }
        return [2 /*return*/];
    });
}); };
var installDependencies = function (destDir) { return __awaiter(void 0, void 0, void 0, function () {
    var spinner, dependencies, devDependencies, err_3;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                spinner = ora('Installing dependencies... ').start();
                dependencies = [
                    '@toptal/picasso-provider',
                    '@toptal/picasso',
                    '@topkit/apollo-client',
                    'react',
                    'react-dom',
                    'styled-components',
                    'typescript',
                    '@apollo/client',
                    'graphql',
                ];
                devDependencies = [
                    '@toptal/davinci-qa',
                    '@toptal/davinci-engine',
                    '@toptal/davinci-syntax',
                    '@toptal/davinci-code',
                    '@toptal/davinci-ci',
                    '@types/react',
                    '@types/react-dom',
                    '@toptal/davinci-storybook',
                    '@toptal/davinci-storybook-theme',
                    '@toptal/davinci-storybook-addons',
                    '@toptal/davinci-storybook-decorators',
                ];
                _a.label = 1;
            case 1:
                _a.trys.push([1, 4, , 5]);
                return [4 /*yield*/, run('yarn', __spreadArray(['add', '-D'], devDependencies, true), {
                        cwd: destDir,
                    })];
            case 2:
                _a.sent();
                return [4 /*yield*/, run('yarn', __spreadArray(['add'], dependencies, true), {
                        cwd: destDir,
                    })];
            case 3:
                _a.sent();
                spinner.succeed('Dependencies installed!');
                return [3 /*break*/, 5];
            case 4:
                err_3 = _a.sent();
                spinner.fail();
                throw new Error(err_3);
            case 5: return [2 /*return*/];
        }
    });
}); };
var createCommand = function (appName) { return __awaiter(void 0, void 0, void 0, function () {
    var currentRunningDir, currentDavinciRunningDir, destDir, err_4;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                print.green('Creating', appName, '...');
                currentRunningDir = process.cwd();
                currentDavinciRunningDir = __dirname;
                destDir = path.join(currentRunningDir, appName);
                _a.label = 1;
            case 1:
                _a.trys.push([1, 6, , 7]);
                // check if all apps are installed, directory doesn't exists
                return [4 /*yield*/, checkPrerequisites(destDir, appName)
                    // copy skeleton to destination directory
                ];
            case 2:
                // check if all apps are installed, directory doesn't exists
                _a.sent();
                // copy skeleton to destination directory
                return [4 /*yield*/, copyApplicationSkeleton(destDir, currentDavinciRunningDir)
                    // change package.json
                ];
            case 3:
                // copy skeleton to destination directory
                _a.sent();
                // change package.json
                return [4 /*yield*/, modifyPackageJson(destDir, appName)
                    // run yarn
                ];
            case 4:
                // change package.json
                _a.sent();
                // run yarn
                return [4 /*yield*/, installDependencies(destDir)];
            case 5:
                // run yarn
                _a.sent();
                print.green('Application has been created.');
                return [3 /*break*/, 7];
            case 6:
                err_4 = _a.sent();
                print.red(err_4);
                process.exit(1);
                return [3 /*break*/, 7];
            case 7: return [2 /*return*/];
        }
    });
}); };
var newCommandCreator = {
    command: 'new <appName>',
    description: 'Create new application',
    action: function (_a) {
        var appName = _a.appName;
        return __awaiter(void 0, void 0, void 0, function () {
            var formattedAppName;
            return __generator(this, function (_b) {
                formattedAppName = kebabCase(appName);
                return [2 /*return*/, createCommand(formattedAppName)];
            });
        });
    },
};
module.exports = newCommandCreator;
