"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var path = require('path');
var fs = require('fs-extra');
var _a = require('../constants'), NODE_MODULES_PATTERN = _a.NODE_MODULES_PATTERN, CHANGELOG_PATTERN = _a.CHANGELOG_PATTERN, DIST_PACKAGE_PATTERN = _a.DIST_PACKAGE_PATTERN, GITHUB_SKELETON_PATTERN = _a.GITHUB_SKELETON_PATTERN, GITHUB_PATH = _a.GITHUB_PATH, CODEBASE_SPECIFIC_WORKFLOWS_PATH = _a.CODEBASE_SPECIFIC_WORKFLOWS_PATH;
var readPackageJson = function (folder) {
    var packageJsonFile = path.join(folder, 'package.json');
    var configData = fs.readFileSync(packageJsonFile);
    return JSON.parse(configData);
};
var writePackageJson = function (folder, config) {
    var packageJsonFile = path.join(folder, 'package.json');
    var modifiedConfigData = JSON.stringify(config, null, 2).concat('\n');
    fs.writeFileSync(packageJsonFile, modifiedConfigData);
};
var copyTemplatePackageJsonFile = function (folder) { return __awaiter(void 0, void 0, void 0, function () {
    var packageJsonFile, packageSkeletonJsonFile;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                packageJsonFile = path.join(folder, 'package.json');
                packageSkeletonJsonFile = path.join(folder, 'package.json.skeleton');
                if (!fs.existsSync(packageSkeletonJsonFile)) return [3 /*break*/, 3];
                return [4 /*yield*/, fs.remove(packageJsonFile)];
            case 1:
                _a.sent();
                return [4 /*yield*/, fs.rename(packageSkeletonJsonFile, packageJsonFile)];
            case 2:
                _a.sent();
                _a.label = 3;
            case 3: return [2 /*return*/];
        }
    });
}); };
var copyTemplateGitIgnoreFile = function (folder) { return __awaiter(void 0, void 0, void 0, function () {
    var gitIgnoreFile, gitIgnoreSkeletonFile;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                gitIgnoreFile = path.join(folder, '.gitignore');
                gitIgnoreSkeletonFile = path.join(folder, '.gitignore.skeleton');
                if (!fs.existsSync(gitIgnoreSkeletonFile)) return [3 /*break*/, 2];
                return [4 /*yield*/, fs.rename(gitIgnoreSkeletonFile, gitIgnoreFile)];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2: return [2 /*return*/];
        }
    });
}); };
var copyTemplateEslintrc = function (folder) { return __awaiter(void 0, void 0, void 0, function () {
    var eslintrcFile, eslintrcSkeletonFile;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                eslintrcFile = path.join(folder, '.eslintrc.js');
                eslintrcSkeletonFile = path.join(folder, '.eslintrc.js.skeleton');
                if (!fs.existsSync(eslintrcSkeletonFile)) return [3 /*break*/, 2];
                return [4 /*yield*/, fs.rename(eslintrcSkeletonFile, eslintrcFile)];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2: return [2 /*return*/];
        }
    });
}); };
var copyNpmrc = function (folder) { return __awaiter(void 0, void 0, void 0, function () {
    var npmrcFile, npmrcFileSkeletonFile;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                npmrcFile = path.join(folder, '.npmrc');
                npmrcFileSkeletonFile = path.join(folder, '.npmrc.skeleton');
                if (!fs.existsSync(npmrcFileSkeletonFile)) return [3 /*break*/, 2];
                return [4 /*yield*/, fs.rename(npmrcFileSkeletonFile, npmrcFile)];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2: return [2 /*return*/];
        }
    });
}); };
var copySPAWorkflows = function (sourceDir, destDir) { return __awaiter(void 0, void 0, void 0, function () {
    var workflowsDir, targetDir;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                workflowsDir = path.join(sourceDir, GITHUB_PATH, CODEBASE_SPECIFIC_WORKFLOWS_PATH, 'spa');
                targetDir = path.join(destDir, GITHUB_PATH, 'workflows');
                return [4 /*yield*/, fs.copy(workflowsDir, targetDir)];
            case 1:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
var copyAllFiles = function (sourceDir, destDir) { return __awaiter(void 0, void 0, void 0, function () {
    var isSkeletonFile;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                isSkeletonFile = function (src) {
                    return !src.match(NODE_MODULES_PATTERN) &&
                        !src.match(DIST_PACKAGE_PATTERN) &&
                        !src.match(CHANGELOG_PATTERN) &&
                        !src.match(GITHUB_SKELETON_PATTERN);
                };
                return [4 /*yield*/, fs.copy(sourceDir, destDir, { filter: isSkeletonFile })];
            case 1:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
module.exports = {
    readPackageJson: readPackageJson,
    writePackageJson: writePackageJson,
    copyTemplatePackageJsonFile: copyTemplatePackageJsonFile,
    copyTemplateGitIgnoreFile: copyTemplateGitIgnoreFile,
    copyTemplateEslintrc: copyTemplateEslintrc,
    copyNpmrc: copyNpmrc,
    copySPAWorkflows: copySPAWorkflows,
    copyAllFiles: copyAllFiles,
};
