"use strict";
var path = require('path');
var fs = require('fs-extra');
var findWorkspaceRoot = require('find-yarn-workspace-root');
var run = require('@toptal/davinci-cli-shared').run;
var getPackageName = function (config) { return config.name; };
var readPackageJson = function (folder) {
    var packageJsonFile = path.join(folder, 'package.json');
    var configData = fs.readFileSync(packageJsonFile);
    var config;
    try {
        config = JSON.parse(configData);
    }
    catch (e) {
        console.warn("package.json file from ".concat(folder, " can't be parsed as valid JSON. Error: "), e);
    }
    return config;
};
var installDependencies = function (folder) { return run('yarn', ['install'], { cwd: folder }); };
module.exports = {
    getRootDir: findWorkspaceRoot,
    readPackageJson: readPackageJson,
    getPackageName: getPackageName,
    installDependencies: installDependencies,
};
